* { box-sizing: border-box; }

// Wrappers
.w {
  width: 90%;
  margin-left: auto;
  margin-right: auto;

  @include wider-than( tablet )  {  width: 96%; max-width: 60rem; }
  @include wider-than( laptop )  {  width: 96%; max-width: 70rem; }
  @include wider-than( desktop ) {  width: 96%; max-width: 80rem; }
  @include wider-than( cinema )  {  width: 96%; max-width: 90rem; }

}


/*
  Spacing between elements

  This needs to be uniform throughout the
  whole site. So what I've done here is
  create two variables that handle everything.

  From a design side of things, you should be
  able to get the vertical rhythm on the site
  sorted by changing these four values.

*/

// padded__content is a way of pushing text away from the
// edge of your container. This allows you to read without
// any issues.
@mixin padded__content( $size: 1.875rem){
  padding: $size / 1.875;
  @include wider-than(laptop) {
    padding: $size;
  }
}

// whitespace_small is a small gutter that you would
// usually apply to the top and bottom of an element.
$small_gutter:  2rem;
@mixin whitespace__small( $element, $element_b: null ){
  #{$element}: $small_gutter / 1.5;
  @if $element_b{
    #{$element_b}: $small_gutter / 1.5;
  }
  @include wider-than( tablet ) {
    #{$element}: $small_gutter;
    @if $element_b{
      #{$element_b}: $small_gutter;
    }
  }
}
// whitespace_large is a larger gutter that you would
// use to completely separate an element from the flow
$large_gutter:  4rem;
@mixin whitespace__large( $element, $element_b: null ){
  #{$element}: $large_gutter / 1.5;
  @if $element_b{
    #{$element_b}: $large_gutter / 1.5;
  }
  @include wider-than( tablet ) {
    #{$element}: $large_gutter;
    @if $element_b{
      #{$element_b}: $large_gutter;
    }
  }
}



/**
 * Grid.
 * @param  int      $i          Amount of columns needed
 * @param  int      $max:       12            Total amount of columns in grid
 * @param  gutter   $guttering: 1.875rem      Space between columns with rem value
 * @param  boolean  $last:      false         Determines final gutter
 * @return width
 *
 * @usage  @include span(6, 12);              Width with gutter
 * @usage  @include span(4, 12, 1rem);        Width with custom gutter
 * @usage  @include span(6, 12, $last:true);  Last element
 */
@mixin span( $i, $max: 12, $guttering: 1.875rem, $last: null){
  // Width without REM support
  $percentage: $i * 100% / $max;
  width: $percentage - 2%;
  // Width for modern browsers
  $percentage: $percentage - 0.01111%;
  $num: $max / $i - 1;
  $margin-right: ($num * $guttering / ($num +1));
  width: calc(#{$percentage} - #{$margin-right});
  // Grid is based on floats
  float: left;
  // If last item
  @if $last == null {
    // Gutter widthout REM support
    margin-right: 2%;
    // Gutter for modern browsers
    margin-right: calc(#{$guttering});
  }
}

@function offset( $i, $max: 12, $guttering: 1.875rem, $last: null){
  $percentage: $i * 100% / $max;
  $percentage: $percentage - 0.001%;
  $num: $max / $i - 1;
  $margin-right: ($num * $guttering / ($num +1));
  @if $last == null {
    @return calc(#{$percentage} + #{$margin-right});
  } @else {
    @return calc(#{$percentage} - #{$margin-right});
  }
}